import type { RawBuiltins, RawHtmlPluginConfig, RawDecoratorOptions, Minification } from "@rspack/binding";
export declare type BuiltinsHtmlPluginConfig = Omit<RawHtmlPluginConfig, "meta"> & {
    meta?: Record<string, string | Record<string, string>>;
};
export declare type Builtins = Omit<RawBuiltins, "define" | "browserslist" | "html" | "decorator" | "minify" | "emotion"> & {
    define?: Record<string, string | undefined>;
    polyfillBuiltins?: boolean;
    html?: Array<BuiltinsHtmlPluginConfig>;
    decorator?: boolean | Partial<RawDecoratorOptions>;
    minify?: boolean | Partial<Minification>;
    emotion?: boolean | {
        sourceMap?: boolean;
        autoLabel?: "never" | "dev-only" | "always";
        labelFormat?: string;
        importMap?: {
            [packageName: string]: {
                [exportName: string]: {
                    canonicalImport?: [string, string];
                };
            };
        };
    };
};
export declare type ResolvedBuiltins = Omit<RawBuiltins, "html"> & {
    polyfillBuiltins?: boolean;
    html?: Array<BuiltinsHtmlPluginConfig>;
    emotion?: string;
};
export declare function resolveBuiltinsOptions(builtins: Builtins, { contextPath, isProduction }: {
    contextPath: string;
    isProduction: boolean;
}): ResolvedBuiltins;
export declare function resolveMinify(builtins: Builtins, isProduction: boolean): Minification;
//# sourceMappingURL=builtins.d.ts.map