import { PluginInstance } from "./plugin";
import { OptimizationSplitChunksOptions } from "./splitChunks";
import type { RawSplitChunksOptions } from "@rspack/binding";
/**
 * Create an additional chunk which contains only the webpack runtime and chunk hash maps.
 */
export declare type OptimizationRuntimeChunk = ("single" | "multiple") | boolean | {
    /**
     * The name or name factory for the runtime chunks.
     */
    name?: string | Function;
};
export declare type OptimizationRuntimeChunkNormalized = false | {
    /**
     * The name factory for the runtime chunks.
     */
    name?: Function;
};
export interface Optimization {
    moduleIds?: "named" | "deterministic";
    minimize?: boolean;
    minimizer?: ("..." | PluginInstance)[];
    splitChunks?: OptimizationSplitChunksOptions;
    runtimeChunk?: OptimizationRuntimeChunk;
    removeAvailableModules?: boolean;
}
export interface ResolvedOptimization {
    moduleIds: "named" | "deterministic";
    minimize?: boolean;
    minimizer?: ("..." | PluginInstance)[];
    splitChunks?: RawSplitChunksOptions;
    removeAvailableModules?: boolean;
}
export declare function getNormalizedOptimizationRuntimeChunk(runtimeChunk: OptimizationRuntimeChunk): OptimizationRuntimeChunkNormalized;
export declare function resolveOptimizationOptions(op: Optimization, mode: string): ResolvedOptimization;
//# sourceMappingURL=optimization.d.ts.map