import * as binding from "@rspack/binding";
import { Compilation } from ".";
import { StatsOptions, StatsOptionsObj } from "./config/stats";
export declare type StatsCompilation = Partial<Omit<binding.JsStatsCompilation, "entrypoints"> & {
    entrypoints: Record<string, binding.JsStatsEntrypoint>;
    filteredModules?: number;
    publicPath?: string;
    children?: StatsCompilation[];
    name?: string;
}>;
export declare class Stats {
    #private;
    compilation: Compilation;
    constructor(compilation: Compilation);
    get hash(): string;
    hasErrors(): boolean;
    hasWarnings(): boolean;
    toJson(opts?: StatsOptions, forToString?: boolean): Partial<Omit<binding.JsStatsCompilation, "entrypoints"> & {
        entrypoints: Record<string, binding.JsStatsEntrypoint>;
        filteredModules?: number | undefined;
        publicPath?: string | undefined;
        children?: Partial<Omit<binding.JsStatsCompilation, "entrypoints"> & any>[] | undefined;
        name?: string | undefined;
    }>;
    toString(opts?: StatsOptions): any;
    static jsonToString(obj: any, useColors: boolean): any;
}
export declare const optionsOrFallback: (...args: (boolean | undefined)[]) => boolean | undefined;
export declare function normalizeStatsPreset(options?: StatsOptions): StatsOptionsObj;
//# sourceMappingURL=stats.d.ts.map